// **********************************************************************
//
// Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.1.1
// Generated from file `FileParser.ice'

#ifndef __IceGrid_FileParser_h__
#define __IceGrid_FileParser_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/IncomingAsync.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <IceGrid/Admin.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 301
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ICE_GRID_API
#   ifdef ICE_GRID_API_EXPORTS
#       define ICE_GRID_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_GRID_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace IceGrid
{

class FileParser;
ICE_GRID_API bool operator==(const FileParser&, const FileParser&);
ICE_GRID_API bool operator!=(const FileParser&, const FileParser&);
ICE_GRID_API bool operator<(const FileParser&, const FileParser&);
ICE_GRID_API bool operator<=(const FileParser&, const FileParser&);
ICE_GRID_API bool operator>(const FileParser&, const FileParser&);
ICE_GRID_API bool operator>=(const FileParser&, const FileParser&);

}

}

namespace IceGrid
{

class FileParser;
ICE_GRID_API bool operator==(const FileParser&, const FileParser&);
ICE_GRID_API bool operator!=(const FileParser&, const FileParser&);
ICE_GRID_API bool operator<(const FileParser&, const FileParser&);
ICE_GRID_API bool operator<=(const FileParser&, const FileParser&);
ICE_GRID_API bool operator>(const FileParser&, const FileParser&);
ICE_GRID_API bool operator>=(const FileParser&, const FileParser&);

}

namespace IceInternal
{

ICE_GRID_API void incRef(::IceGrid::FileParser*);
ICE_GRID_API void decRef(::IceGrid::FileParser*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::FileParser*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::FileParser*);

}

namespace IceGrid
{

typedef ::IceInternal::Handle< ::IceGrid::FileParser> FileParserPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::FileParser> FileParserPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const FileParserPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, FileParserPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const FileParserPtr&);
ICE_GRID_API void __patch__FileParserPtr(void*, ::Ice::ObjectPtr&);

}

namespace IceGrid
{

class ICE_GRID_API ParseException : public ::Ice::UserException
{
public:

    ParseException() {}
    explicit ParseException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string reason;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static ParseException __ParseException_init;

}

namespace IceAsync
{

}

namespace IceProxy
{

namespace IceGrid
{

class ICE_GRID_API FileParser : virtual public ::IceProxy::Ice::Object
{
public:

    ::IceGrid::ApplicationDescriptor parse(const ::std::string& xmlFile, const ::IceGrid::AdminPrx& adminProxy)
    {
	return parse(xmlFile, adminProxy, __defaultContext());
    }
    ::IceGrid::ApplicationDescriptor parse(const ::std::string&, const ::IceGrid::AdminPrx&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace IceGrid
{

class ICE_GRID_API FileParser : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::IceGrid::ApplicationDescriptor parse(const ::std::string&, const ::IceGrid::AdminPrx&, const ::Ice::Context&) = 0;
};

}

}

namespace IceDelegateM
{

namespace IceGrid
{

class ICE_GRID_API FileParser : virtual public ::IceDelegate::IceGrid::FileParser,
				virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::IceGrid::ApplicationDescriptor parse(const ::std::string&, const ::IceGrid::AdminPrx&, const ::Ice::Context&);
};

}

}

namespace IceDelegateD
{

namespace IceGrid
{

class ICE_GRID_API FileParser : virtual public ::IceDelegate::IceGrid::FileParser,
				virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::IceGrid::ApplicationDescriptor parse(const ::std::string&, const ::IceGrid::AdminPrx&, const ::Ice::Context&);
};

}

}

namespace IceGrid
{

class ICE_GRID_API FileParser : virtual public ::Ice::Object
{
public:

    typedef FileParserPrx ProxyType;
    typedef FileParserPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::IceGrid::ApplicationDescriptor parse(const ::std::string&, const ::IceGrid::AdminPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___parse(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_GRID_API __patch__FileParserPtr(void*, ::Ice::ObjectPtr&);

}

#endif
